'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports['default'] = graphql;

var _parse = require('./parser');

var _parse2 = _interopRequireWildcard(_parse);

var _transform = require('./transform');

var _transform2 = _interopRequireWildcard(_transform);

var _Transformer = require('./transform/transformer');

var _Transformer2 = _interopRequireWildcard(_Transformer);

var _import = require('graphql-types');

var GraphQL = _interopRequireWildcard(_import);

var _import2 = require('./types');

var Types = _interopRequireWildcard(_import2);

exports.parse = _parse2['default'];
exports.GraphQL = GraphQL;
exports.Transformer = _Transformer2['default'];
exports.Types = Types;

function graphql(strings) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var source = strings[0] || '';
  for (var i = 1; i < strings.length; i++) {
    source += '&' + (i - 1);
    source += strings[i];
  }

  var ast = _parse2['default'](source);
  return function (params) {
    var state = {
      arguments: args,
      variables: params };

    return _transform2['default'](ast, state);
  };
}